/*
 * libspe - A wrapper library to adapt the JSRE SPU usage model to SPUFS
 * Copyright (C) 2005 IBM Corp.
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License,
 * or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 *  License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public License
 *   along with this library; if not, write to the Free Software Foundation,
 *   Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#define LS_SIZE                       0x40000	/* 256K (in bytes) */

#define SPE_LDR_PROG_start    (LS_SIZE - 512)	// location of spu_ld.so prog
#define SPE_LDR_PARAMS_start  (LS_SIZE - 128)	// location of spu_ldr_params
#define SPE_SYSCALL_ADDR      (LS_SIZE - 1024)	// location of syscall data block in PPE mem

typedef union
{
	unsigned long long ull;
	unsigned int ui[2];
} addr64;

struct spe_ld_info
{
	unsigned int entry;	/* Entry point of SPU image                 */
};

/*
 * Global API : */

int load_spe_elf (void *elf_start, void *ld_buffer,
		  struct spe_ld_info *ld_info);
