/* @(#)60	1.47  src/include/spu/mfc.h, sw.includes, sdk2, SDK0.28 5/25/05 18:28:13 */
/* --------------------------------------------------------------  */
/* PLEASE DO NOT MODIFY THIS SECTION                               */
/* This prolog section is automatically generated.                 */
/*                                                                 */
/* (C)Copyright                                                    */
/* Sony Computer Entertainment, Inc.,                              */
/* Toshiba Corporation,                                            */
/* International Business Machines Corporation,                    */
/* 2001,2005.  All rights reserved.                                */
/* S/T/I Confidential Information                                  */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */
/* Copyright (C) 2000,2001 IBM Corporation */ 

#ifndef _mfc_h_
#define _mfc_h_

#ifdef MFC_DEBUG
#include <stdio.h>
#endif

#include <spu_intrinsics.h>


/* Interfaces derived from "Broadband Processor Architecture",
 * Draft v 1.2.
 */

/* ============================================================================
   Refer to the "MFC Library" section of the "STI Design Center Cell Processor 
   Libraries" document for the official "detailed" description of the following 
   subroutines, etc..
 */

/* ============================================================================
   Error checking is conditional in the following MFC subroutines.

   To maximize performance of this code, compile with the MFC_ERROR_CHECK,
   DEBUG_MFC_ERROR_CHECK, and DEBUG_SPU_MFC defines NOT set.

   To enable basic error checking of parameters passed to these routines,
   set the MFC_ERROR_CHECK compile define.  To have these routines
   generate debug messages, set the DEBUG_MFC_ERROR_CHECK compile 
   define also.  This allows one to quickly determine problems in 
   applications using the MFC routines without requiring that the 
   applications be modified to check return codes, interpret, and
   print messages.

   When error checking is enabled, some MFC subroutines will return MFC_ERROR 
   (-1) when an error occurs.

   To generate more debug messages showing the values of all parameters passed
   to these routines and the addresses and data of all MFC read/writes, set the
   DEBUG_SPU_MFC compile define.

   Setting the MFC_DEBUG define automatically sets the MFC_ERROR_CHECK,
   DEBUG_MFC_ERROR_CHECK, and DEBUG_SPU_MFC defines.
 */

#ifdef MFC_DEBUG
 #ifndef MFC_ERROR_CHECK
 #define MFC_ERROR_CHECK 1
 #endif
 #ifndef DEBUG_SPU_MFC
 #define DEBUG_SPU_MFC 1
 #endif
 #ifndef DEBUG_MFC_ERROR_CHECK
 #define DEBUG_MFC_ERROR_CHECK 1
 #endif
#endif

#ifdef DEBUG_SPU_MFC
#define SPU_MFC_DEBUG(...)		printf(__VA_ARGS__)
#else
#define SPU_MFC_DEBUG(...)
#endif

#ifdef DEBUG_MFC_ERROR_CHECK
#define MFC_ERROR_CHECK_DEBUG(...)	printf(__VA_ARGS__)
#else
#define MFC_ERROR_CHECK_DEBUG(...)
#endif

/* This section contains various definitions related to the Memory Flow
   Controller (MFC) portion of the Broadband Processor Architecture (BPA).

   The structures defining the mapping of the MFC from the PU side and 
   various other registers in the BPA are located in bpa_map.h.
 */

/****************************************************************************/
/* MFC DMA Command flags which identify classes of operations. */
/****************************************************************************/
/* Note: These flags may be used in conjunction with the base command types
	 (i.e. MFC_PUT_CMD, MFC_PUTR_CMD, MFC_GET_CMD, and MFC_SNDSIG_CMD)
	 to construct the various command permutations.
 */

#define MFC_BARRIER_ENABLE      0x01
#define MFC_FENCE_ENABLE        0x02
#define MFC_LIST_ENABLE         0x04  /* SPU Only */
#define MFC_RESULT_ENABLE       0x10

/****************************************************************************/
/* MFC DMA Put Commands */
/****************************************************************************/

#define MFC_PUT_CMD             0x20
#define MFC_PUTR_CMD            0x30
#define MFC_PUTF_CMD            0x22
#define MFC_PUTB_CMD            0x21
#define MFC_PUTRF_CMD           0x32
#define MFC_PUTRB_CMD           0x31
#define MFC_PUTL_CMD            0x24  /* SPU Only */
#define MFC_PUTRL_CMD           0x34  /* SPU Only */
#define MFC_PUTLF_CMD           0x26  /* SPU Only */
#define MFC_PUTLB_CMD           0x25  /* SPU Only */
#define MFC_PUTRLF_CMD          0x36  /* SPU Only */
#define MFC_PUTRLB_CMD          0x35  /* SPU Only */

/****************************************************************************/
/* MFC DMA Get Commands */
/****************************************************************************/

#define MFC_GET_CMD             0x40
#define MFC_GETF_CMD            0x42
#define MFC_GETB_CMD            0x41
#define MFC_GETL_CMD            0x44  /* SPU Only */
#define MFC_GETLF_CMD           0x46  /* SPU Only */
#define MFC_GETLB_CMD           0x45  /* SPU Only */

/****************************************************************************/
/* MFC DMA Storage Control Commands */
/****************************************************************************/
/* Note: These are only supported on implementations with a SL1 cache
	 They are no-ops on the initial BE implementation.
 */

#define MFC_SDCRT_CMD           0x80
#define MFC_SDCRTST_CMD         0x81
#define MFC_SDCRZ_CMD           0x89
#define MFC_SDCRS_CMD           0x8D
#define MFC_SDCRF_CMD           0x8F

/****************************************************************************/
/* MFC Synchronization Commands */
/****************************************************************************/

#define MFC_GETLLAR_CMD         0xD0  /* SPU Only */
#define MFC_PUTLLC_CMD          0xB4  /* SPU Only */
#define MFC_PUTLLUC_CMD         0xB0  /* SPU Only */
#define MFC_PUTQLLUC_CMD	0xB8  /* SPU Only - DD 2.0 */
#define MFC_SNDSIG_CMD          0xA0
#define MFC_SNDSIGB_CMD         0xA1
#define MFC_SNDSIGF_CMD         0xA2
#define MFC_BARRIER_CMD         0xC0
#define MFC_EIEIO_CMD           0xC8
#define MFC_SYNC_CMD            0xCC

/********************************************/
/* MFC PU Side Register Utility Definitions */
/********************************************/

/****************************************************************************/
/* Definitions related to the PU DMA Command registers.
   (DMA_LSA, DMA_EAL, DMA_EAH, DMA_Size, DMA_Tag, DMA_ClassID, DMA_CMD)
 */
/****************************************************************************/

/****************************************************************************/
/* Definitions for constructing a 32-bit command word including the transfer
   and replacement class id and the command opcode.
 */
/****************************************************************************/
#define MFC_TCLASS(_tid)       ((_tid) << 24)
#define MFC_RCLASS(_rid)       ((_rid) << 16)

#define MFC_CMD_WORD(_tid, _rid, _cmd) \
 (MFC_TCLASS(_tid) | MFC_RCLASS(_rid) | (_cmd))

/****************************************************************************/
/* Definitions for constructing a 64-bit command word including the size, tag,
   transfer and replacement class id and the command opcode.
 */
/****************************************************************************/
#define MFC_SIZE(_size)        ((unsigned long long)(_size) << 48)
#define MFC_TAG(_tag_id)       ((unsigned long long)(_tag_id) << 32)
#define MFC_TR_CMD(_trcmd)     ((unsigned long long)(_trcmd))

#define MFC_CMD_DWORD(_size, _tag_id, _trcmd)  \
 (MFC_SIZE(_size) | MFC_TAG(_tag_id) | MFC_TR_CMD(_trcmd))

/****************************************************************************/
/* Mask definitions for obtaining DMA commands and class ids from packed words.
 */
/****************************************************************************/
#define MFC_CMD_MASK       0x0000FFFF
#define MFC_CLASS_MASK     0x000000FF

/****************************************************************************/
/* DMA max/min size definitions. */
/****************************************************************************/
#define MFC_MIN_DMA_SIZE_SHIFT	4	/* 16 bytes */
#define MFC_MAX_DMA_SIZE_SHIFT	14	/* 16384 bytes */

#define MFC_MIN_DMA_SIZE	(1 << MFC_MIN_DMA_SIZE_SHIFT)
#define MFC_MAX_DMA_SIZE	(1 << MFC_MAX_DMA_SIZE_SHIFT)

#define MFC_MIN_DMA_SIZE_MASK	(MFC_MIN_DMA_SIZE - 1)
#define MFC_MAX_DMA_SIZE_MASK	(MFC_MAX_DMA_SIZE - 1)

#define MFC_MIN_DMA_LIST_SIZE   0x0008  /*   8 bytes */
#define MFC_MAX_DMA_LIST_SIZE   0x4000  /* 16K bytes */

/****************************************************************************/
/* Mask definition for checking proper address alignment. */
/****************************************************************************/
#define MFC_ADDR_MATCH_MASK     0xF
#define MFC_BEST_ADDR_ALIGNMENT 0x80

/****************************************************************************/
/* Definitions related to the DMA Queue Status register (DMA_QStatus). */
/****************************************************************************/
#define MFC_SPU_MAX_QUEUE_SPACE		0x10

/****************************************************************************/
/* Definitions related to the Mailbox Status register (MB_stat) and the depths
 * of the PPC Core Mailbox Register (PU_MB), SPU Mailbox Register (SPU_MB),
 * and PPC Core Interrupt Mailbox Register (PUINT_MB). */
/****************************************************************************/
#define MFC_SPU_TO_PU_MAILBOX_STATUS_MASK		0x000000FF
#define MFC_SPU_TO_PU_MAILBOX_STATUS_SHIFT		0x0
#define MFC_SPU_TO_PU_MAILBOX_DEPTH			0x1
#define MFC_SPU_TO_PU_MAILBOX_EMPTY			0x0
#define MFC_PU_TO_SPU_MAILBOX_STATUS_MASK		0x0000FF00
#define MFC_PU_TO_SPU_MAILBOX_STATUS_SHIFT		0x8
#define MFC_PU_TO_SPU_MAILBOX_DEPTH			0x4
#define MFC_PU_TO_SPU_MAILBOX_EMPTY			0x4
#define MFC_SPU_TO_PU_INT_MAILBOX_STATUS_MASK		0x00FF0000
#define MFC_SPU_TO_PU_INT_MAILBOX_STATUS_SHIFT		0x10
#define MFC_SPU_TO_PU_INT_MAILBOX_DEPTH			0x1
#define MFC_SPU_TO_PU_INT_MAILBOX_EMPTY			0x0

/****************************************************************************/
/* Definitions related to the SPC Multi Source Syncronization register
 * (SPC_MSSync). */
/****************************************************************************/
#define MFC_SPC_MSS_STATUS_MASK                      0x1
#define MFC_SPC_MSS_COMPLETE                         0x0
#define MFC_SPC_MSS_NOT_COMPLETE                     0x1

/****************************************************************************
* MFC Channels
****************************************************************************/
/*******************************************
* SPU Event and Signalling Channels (0 - 4)
*******************************************/

// Events for Channels 0-2
#define     MFC_DMA_TAG_STATUS_UPDATE_EVENT	0x00000001
#define	    MFC_DMA_TAG_CMD_STALL_NOTIFY_EVENT	0x00000002
#define	    MFC_DMA_QUEUE_AVAILABLE_EVENT	0x00000008
#define	    MFC_SPU_MAILBOX_WRITTEN_EVENT	0x00000010
#define	    MFC_DECREMENTER_EVENT		0x00000020
#define	    MFC_PU_INT_MAILBOX_AVAILABLE_EVENT	0x00000040
#define	    MFC_PU_MAILBOX_AVAILABLE_EVENT	0x00000080
#define	    MFC_SIGNAL_2_EVENT			0x00000100
#define	    MFC_SIGNAL_1_EVENT			0x00000200
#define	    MFC_LLR_LOST_EVENT			0x00000400
#define	    MFC_PRIV_ATTN_EVENT		        0x00000800
#define     MFC_MULTI_SRC_EVENT                 0x00001000

/**********************************
* SPU Event Channels (0 - 2)
**********************************/
// Channel 0
#define MFC_RD_EVENT_STATUS		0
#define		MFC_EVENT_NOT_TRIGGERED		0x0
#define		MFC_EVENT_TRIGGERED		0x1

// Channel 1
#define MFC_WR_EVENT_MASK		1
#define		MFC_EVENT_MASKED		0x0
#define		MFC_EVENT_ENABLED		0x1

// Channel 2
#define MFC_WR_EVENT_ACK		2
#define		MFC_EVENT_NO_ACK		0x0
#define		MFC_EVENT_ACK			0x1

/**********************************
* SPU Signal Notification Channels (3 - 4)
**********************************/
// Channels 3-4
#define MFC_RD_SIGNAL_1			3
#define MFC_RD_SIGNAL_2			4

/**********************************
* SPU Decrementer Channels (7 - 8)
**********************************/
#define MFC_WR_DECR_COUNT		7
#define MFC_RD_DECR_COUNT		8

/**********************************
* SPU Multi-Sourced Synchronization Request (9)
**********************************/
#define MFC_WR_MULTI_SRC_SYNC_REQ       9

/**********************************
* SPU Read Mask Channels (11 - 12)
**********************************/
#define MFC_RD_EVENT_MASK		11
#define MFC_RD_TAG_MASK			12

/**********************************
* SPU State Management Channels (13 - 15)
**********************************/
#define MFC_RD_RUN_STATUS		13	/* x'D' */
#define MFC_WR_SRR0			14	/* x'E' */
#define MFC_RD_SRR0			15	/* x'F' */

/*********************************
* DMA Command Channels (16 - 21)
*********************************/
#define MFC_LS_ADDR			16	/* x'10' */
#define MFC_EA_HI			17	/* x'11' */
#define MFC_EA_LOW			18	/* x'12' */
#define MFC_DMA_SIZE			19	/* x'13' */
#define MFC_TAG_ID			20	/* x'14' */
#define MFC_CMD_QUEUE			21	/* x'15' */

/***********************************
* DMA TAG Status Channels (22 - 27)
***********************************/
#define MFC_WR_TAG_MASK			22	/* x'16' */
#define MFC_WR_TAG_UPDATE		23	/* x'17' */
#define		MFC_TAG_UPDATE_IMMED		0x0
#define		MFC_TAG_UPDATE_ANY		0x1
#define		MFC_TAG_UPDATE_ALL		0x2
#define MFC_RD_TAG_STATUS		24	/* x'18' */
#define MFC_RD_DMAL_STATUS		25	/* x'19' */
#define MFC_WR_DMAL_ACK			26	/* x'1A' */
#define MFC_RD_LLAR_STATUS		27	/* x'1B' */
#define	   MFC_PUTLLC_STATUS		    0x00000001
#define		MFC_PUTLLC_FAILED		0x1
#define		MFC_PUTLLC_SUCCESS		0x0
#define	   MFC_PUTLLUC_STATUS		    0x00000002
#define	   MFC_GETLLAR_STATUS		    0x00000004

/******************************************
* PU/SPU Communication Mailboxes (28 - 30)
******************************************/
#define MFC_WR_MAILBOX			28	/* x'1C' */
#define MFC_RD_MAILBOX			29	/* x'1D' */
#define MFC_WR_INTR_MAILBOX		30	/* x'1E' */

/******************************************
* SPU Isolation Control (64)
******************************************/
#define MFC_WR_ISOLATION_CONTROL	64	/* x'40' */

/****************************************************************************/
/* END OF MFC Declarations.                                                 */
/****************************************************************************/


/* MFC Error definitions.
 */
#define MFC_ERROR	-1	// Failure from PU side MFC routine


/* The following checks are only performed if the MFC_ERROR_CHECK define is
   set at compile time.  If an error is detected by one of these checks then
   a debug message can be printed by setting the DEBUG_MFC_ERROR_CHECK.  After
   an application is running smoothly with the checks in place, recompile 
   with MFC_ERROR_CHECK NOT set to maximize performance of this code, by 
   elminating the error checking overhead.
 */

#ifdef CONFIG_BPA_RFC_35
 #define CHECK_CASE_MFC_PUTQLLUC		    case MFC_PUTQLLUC_CMD:
#else
 #define CHECK_CASE_MFC_PUTQLLUC
#endif


/* Check to insure a valid cmd was passed.
 */
#ifdef MFC_ERROR_CHECK
#define CHECK_MFC_DMA_CMD(cmd)                                                \
{                                                                             \
  /* CHECK_MFC_DMA_CMD */                                                     \
  unsigned int chk_cmd = cmd & MFC_CMD_MASK;                                  \
  switch(chk_cmd)                                                             \
  {                                                                           \
    case MFC_PUT_CMD:                                                         \
      break;                                                                  \
    case MFC_PUTR_CMD:                                                        \
      break;                                                                  \
    case MFC_PUTF_CMD:                                                        \
      break;                                                                  \
    case MFC_PUTB_CMD:                                                        \
      break;                                                                  \
    case MFC_PUTRF_CMD:                                                       \
      break;                                                                  \
    case MFC_PUTRB_CMD:                                                       \
      break;                                                                  \
    case MFC_PUTL_CMD:                                                        \
      break;                                                                  \
    case MFC_PUTRL_CMD:                                                       \
      break;                                                                  \
    case MFC_PUTLF_CMD:                                                       \
      break;                                                                  \
    case MFC_PUTLB_CMD:                                                       \
      break;                                                                  \
    case MFC_PUTRLF_CMD:                                                      \
      break;                                                                  \
    case MFC_PUTRLB_CMD:                                                      \
      break;                                                                  \
    case MFC_GET_CMD:                                                         \
      break;                                                                  \
    case MFC_GETF_CMD:                                                        \
      break;                                                                  \
    case MFC_GETB_CMD:                                                        \
      break;                                                                  \
    case MFC_GETL_CMD:                                                        \
      break;                                                                  \
    case MFC_GETLF_CMD:                                                       \
      break;                                                                  \
    case MFC_GETLB_CMD:                                                       \
      break;                                                                  \
    case MFC_SDCRT_CMD:                                                       \
      break;                                                                  \
    case MFC_SDCRTST_CMD:                                                     \
      break;                                                                  \
    case MFC_SDCRZ_CMD:                                                       \
      break;                                                                  \
    case MFC_SDCRS_CMD:                                                       \
      break;                                                                  \
    case MFC_SDCRF_CMD:                                                       \
      break;                                                                  \
    case MFC_GETLLAR_CMD:                                                     \
      break;                                                                  \
    case MFC_PUTLLC_CMD:                                                      \
      break;                                                                  \
    CHECK_CASE_MFC_PUTQLLUC						      \
    case MFC_PUTLLUC_CMD:                                                     \
      break;                                                                  \
    case MFC_SNDSIG_CMD:                                                      \
      break;                                                                  \
    case MFC_SNDSIGB_CMD:                                                     \
      break;                                                                  \
    case MFC_SNDSIGF_CMD:                                                     \
      break;                                                                  \
    case MFC_BARRIER_CMD:                                                     \
      break;                                                                  \
    case MFC_EIEIO_CMD:                                                       \
      break;                                                                  \
    case MFC_SYNC_CMD:                                                        \
      break;                                                                  \
    default:                                                                  \
      MFC_ERROR_CHECK_DEBUG("\nMFC ERROR MSG: The specified MFC command ");   \
      MFC_ERROR_CHECK_DEBUG("(0x%X) is not supported!\n", chk_cmd);           \
      return(MFC_ERROR);                                                      \
  }                                                                           \
}
#else // MFC_ERROR_CHECK
#define CHECK_MFC_DMA_CMD(cmd)
#endif // MFC_ERROR_CHECK


/* Check to make sure size is either 0,1,2,4,8, 16 or a multiple of 16 bytes
   and not greater than the maximum size allowed for non-list DMAs.  Check to
   make sure list DMAs are always a multiple of 8 bytes.
   This macro assumes that the CHECK_MFC_DMA_CMD macro has been previously
   called in order to validate the cmd parameter.
 */
#ifdef MFC_ERROR_CHECK
#define CHECK_MFC_DMA_SIZE(size, cmd)                                         \
{                                                                             \
  /* CHECK_MFC_DMA_SIZE */                                                    \
  if ( cmd & MFC_LIST_ENABLE)                                                 \
  {                                                                           \
    if ( (size % MFC_MIN_DMA_LIST_SIZE) ||  /* not a multiple of min size? */ \
         (size > MFC_MAX_DMA_LIST_SIZE) )   /* larger than max size? */       \
    {                                                                         \
      MFC_ERROR_CHECK_DEBUG("\nMFC ERROR MSG: The specified DMA command ");   \
      MFC_ERROR_CHECK_DEBUG("size (0x%X) is not supported for\n", size);      \
      MFC_ERROR_CHECK_DEBUG(" LIST cmd = 0x%08X!\n", cmd);                    \
      return(MFC_ERROR);                                                      \
    }                                                                         \
  }                                                                           \
  else if ( !( (size == 1) || (size == 2) || (size == 4) || (size == 8) ||    \
	       (size == 0) ) )                                                \
  {                                                                           \
    if ( (size % MFC_MIN_DMA_SIZE) ||  /* not a multiple of min size? */      \
         (size > MFC_MAX_DMA_SIZE) )   /* larger than max size? */            \
    {                                                                         \
      MFC_ERROR_CHECK_DEBUG("\nMFC ERROR MSG: The specified DMA command ");   \
      MFC_ERROR_CHECK_DEBUG("size (0x%X) is not supported for\n", size);      \
      MFC_ERROR_CHECK_DEBUG(" Non-LIST cmd = 0x%08X!\n", cmd);                \
      return(MFC_ERROR);                                                      \
    }                                                                         \
  }                                                                           \
}
#else // MFC_ERROR_CHECK
#define CHECK_MFC_DMA_SIZE(size, cmd)
#endif // MFC_ERROR_CHECK

/* Check to make sure size is either 0,1,2,4,8,16 or a multiple of 16 bytes.
   Note: The difference between this macro and the CHECK_MFC_DMA_SIZE
   macro is that the size is unlimited, but must be a multiple of the min size.
 */
#ifdef MFC_ERROR_CHECK
#define CHECK_MFC_DMA_LARGE_SIZE(size, cmd)                                   \
{                                                                             \
  /* CHECK_MFC_DMA_LARGE_SIZE */                                              \
  if ( cmd & MFC_LIST_ENABLE)                                                 \
  {                                                                           \
    if (size % MFC_MIN_DMA_LIST_SIZE)   /* not a multiple of min size? */     \
    {                                                                         \
      MFC_ERROR_CHECK_DEBUG("\nMFC ERROR MSG: The specified DMA command ");   \
      MFC_ERROR_CHECK_DEBUG("size (0x%X) is not supported for\n", size);      \
      MFC_ERROR_CHECK_DEBUG(" LIST cmd = 0x%08X!\n", cmd);                    \
      return(MFC_ERROR);                                                      \
    }                                                                         \
  }                                                                           \
  else if ( !( (size == 1) || (size == 2) || (size == 4) || (size == 8) ||    \
	       (size == 0) ) )                                                \
  {                                                                           \
    if (size % MFC_MIN_DMA_SIZE)   /* not a multiple of min size? */          \
    {                                                                         \
      MFC_ERROR_CHECK_DEBUG("\nMFC ERROR MSG: The specified DMA command ");   \
      MFC_ERROR_CHECK_DEBUG("size (0x%X) is not supported for\n", size);      \
      MFC_ERROR_CHECK_DEBUG(" Non-LIST cmd = 0x%08X!\n", cmd);                \
      return(MFC_ERROR);                                                      \
    }                                                                         \
  }                                                                           \
}
#else // MFC_ERROR_CHECK
#define CHECK_MFC_DMA_LARGE_SIZE(size, cmd)
#endif // MFC_ERROR_CHECK


/* Check to make sure that bits 28-31 of both lsaddr and ea are
   aligned to a size boundary and that the least significant 
   4 bits of lsaddr match ea.
   This macro assumes that the CHECK_MFC_DMA_SIZE or CHECK_MFC_DMA_LARGE_SIZE
   macro has been previously called in order to validate the size parameter.
 */
#ifdef MFC_ERROR_CHECK
#define CHECK_MFC_DMA_ADDR_ALIGNED(lsaddr, ea, size)                          \
{                                                                             \
  /* CHECK_MFC_DMA_ADDR_ALIGNED */                                            \
  if ( size < MFC_MIN_DMA_SIZE )                                              \
  { /* sizes less than 16 bytes must be size aligned */                       \
    if ( ((unsigned int)lsaddr & (size-1)) ||/* aligned to size boundary? */  \
         ((unsigned int)ea     & (size-1)) ||/* aligned to size boundary? */  \
         (((unsigned int)ea & MFC_ADDR_MATCH_MASK) !=      /* do least sig*/  \
          ((unsigned int)lsaddr & MFC_ADDR_MATCH_MASK)) )  /* bits match? */  \
    {                                                                         \
      MFC_ERROR_CHECK_DEBUG("\nMFC ERROR MSG: Incorrect alignment of the ");  \
      MFC_ERROR_CHECK_DEBUG("specified Local Store (0x%08X)\n and/or ",       \
		      (unsigned int)lsaddr);                                  \
      MFC_ERROR_CHECK_DEBUG("Effective (0x%016llX) Address! size = 0x%X\n",   \
		      (unsigned long long)(unsigned long)ea, size);           \
      return(MFC_ERROR);                                                      \
    }                                                                         \
  }                                                                           \
  else /* lsaddr and ea address must be a aligned to a 16 byte boundary */    \
  {                                                                           \
    if ( ((unsigned int)lsaddr & (MFC_MIN_DMA_SIZE-1)) ||                     \
         ((unsigned int)ea     & (MFC_MIN_DMA_SIZE-1)) )                      \
    {                                                                         \
      MFC_ERROR_CHECK_DEBUG("\nMFC ERROR MSG: Incorrect alignment of the ");  \
      MFC_ERROR_CHECK_DEBUG("specified Local Store (0x%08X)\n and/or ",       \
		      (unsigned int)lsaddr);                                  \
      MFC_ERROR_CHECK_DEBUG("Effective (0x%016llX) Address! size = 0x%X\n",   \
		      (unsigned long long)(unsigned long)ea, size);           \
      return(MFC_ERROR);                                                      \
    }                                                                         \
  }                                                                           \
}
#else // MFC_ERROR_CHECK
#define CHECK_MFC_DMA_ADDR_ALIGNED(lsaddr, ea, size)
#endif // MFC_ERROR_CHECK

// Check to make sure the tag_id passed is valid.
#ifdef MFC_ERROR_CHECK
#define CHECK_MFC_DMA_TAGID(tag_id)                                           \
{                                                                             \
  /* CHECK_MFC_DMA_TAGID */                                                   \
  if (tag_id > 31)                                                            \
  {                                                                           \
    MFC_ERROR_CHECK_DEBUG("\nMFC ERROR MSG: The specified tag id (0x%X) is",  \
	    		tag_id);                                              \
    MFC_ERROR_CHECK_DEBUG(" not within the range 0 to 31!\n");                \
    return(MFC_ERROR);                                                        \
  }                                                                           \
}
#else // MFC_ERROR_CHECK
#define CHECK_MFC_DMA_TAGID(tag_id)
#endif // MFC_ERROR_CHECK

// Check to make sure the lsaddr passed is valid.
#ifdef MFC_ERROR_CHECK
#define CHECK_MFC_DMA_LS_ADDR(lsaddr)                                         \
{                                                                             \
  /* CHECK_MFC_DMA_LS_ADDR */                                                 \
  if ((unsigned int)lsaddr >= LS_SIZE)                                        \
  {                                                                           \
    MFC_ERROR_CHECK_DEBUG("\nMFC WARNING MSG: The specified Local Store");      \
    MFC_ERROR_CHECK_DEBUG(" Address (%p) is wrapped\n", lsaddr);           \
    return(MFC_ERROR);                                                        \
  }                                                                           \
}
#else // MFC_ERROR_CHECK
#define CHECK_MFC_DMA_LS_ADDR(lsaddr)
#endif // MFC_ERROR_CHECK

/* MFC DMA list element definition.
 */
typedef struct _mfcListElement {
  unsigned int size;
  unsigned int ea;
} mfcListElement __attribute__ ((aligned (8)));

/* MFC_TRANSFER_ALIGN typedef
 *
 * This typedef and the GET_ALIGN_ADDR define is intended to help a 
 * programmer obtain the appropriate alignment offset within a 16 byte 
 * region in local store when performing DMAs which are 1,2,4, or 8 bytes.
 * The BPB v1.2 indicates that the source and destination address for these
 * types of transfers MUST have the same 4 least significant bits and must
 * also be size aligned.
 *
 * For example, this typedef and define can be used to determine the addresses
 * to correctly send signals between SPUs, as shown below:
 *
 * MFC_TRANSFER_ALIGN ls_sig1;
 *    (Allocates a 16 byte character array on a 16 byte boundary.)
 *
 * void *ls_sig1_addr = (void *)GET_ALIGN_ADDR(ls_sig1, Sig_Notify_1);
 *    (Sets the ls_sig1_addr pointer at the appropriate byte in the ls_sig1
 *     character array such that the alignment (least significant 4 bits)
 *     is the same between ls_sig1_addr and Sig_Notify_1.)
 *
 */
typedef struct _mfcTransferAlign {
  unsigned char align[16];
} MFC_TRANSFER_ALIGN __attribute__ ((aligned (16)));

#define GET_ALIGN_ADDR(var, alignment) (&var.align[alignment&0xF])

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

/* To enable the _mfc_cmd*_large() routines, set the _MFC_USE_CMD_LARGE define
 * at compile time.  These routines are capable of properly splitting up DMAs
 * which are larger than the maximum DMA supported by a single command.  
 * Multiple DMAs of the maximum size and any remainder will be initiated using
 * the same tag id.
 */
#ifdef _MFC_USE_CMD_LARGE
  #define _MFC_CMD	_mfc_cmd_large
  #define _MFC_CMD64	_mfc_cmd64_large
#else
  #define _MFC_CMD	_mfc_cmd
  #define _MFC_CMD64	_mfc_cmd64
#endif /* _MFC_USE_CMD_LARGE */

/***************************************************************************/
/* 32-bit Effective Address MFC routines */
/***************************************************************************/

/* Convenience macros for MFC DMA read operations.  
 */
#define _read_mfc(_lsaddr, _ea, _size, _tag_id, _tid, _rid)	\
	_MFC_CMD (_lsaddr, _ea, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_GET_CMD))

#define _read_mfc_b(_lsaddr, _ea, _size, _tag_id, _tid, _rid)	\
	_MFC_CMD (_lsaddr, _ea, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_GETB_CMD))

#define _read_mfc_f(_lsaddr, _ea, _size, _tag_id, _tid, _rid)	\
	_MFC_CMD (_lsaddr, _ea, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_GETF_CMD))

#define _read_mfc_l(_lsaddr, _list, _size, _tag_id, _tid, _rid)	\
	_mfc_cmd (_lsaddr, (unsigned int)(_list), _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_GETL_CMD))

#define _read_mfc_lb(_lsaddr, _list, _size, _tag_id, _tid, _rid) \
	_mfc_cmd (_lsaddr, (unsigned int)(_list), _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_GETLB_CMD))

#define _read_mfc_lf(_lsaddr, _list, _size, _tag_id, _tid, _rid) \
	_mfc_cmd (_lsaddr, (unsigned int)(_list), _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_GETLF_CMD))


/* Convenience macros for MFC DMA write operations.
 */
#define _write_mfc(_ea, _lsaddr, _size, _tag_id, _tid, _rid)	\
	_MFC_CMD (_lsaddr, _ea, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUT_CMD))

#define _write_mfc_b(_ea, _lsaddr, _size, _tag_id, _tid, _rid)	\
	_MFC_CMD (_lsaddr, _ea, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTB_CMD))

#define _write_mfc_f(_ea, _lsaddr, _size, _tag_id, _tid, _rid)	\
	_MFC_CMD (_lsaddr, _ea, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTF_CMD))

#define _write_mfc_l(_list, _lsaddr, _size, _tag_id, _tid, _rid)	\
	_mfc_cmd (_lsaddr, (unsigned int)(_list), _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTL_CMD))

#define _write_mfc_r(_ea, _lsaddr, _size, _tag_id, _tid, _rid)	\
	_MFC_CMD (_lsaddr, _ea, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTR_CMD))

#define _write_mfc_lb(_list, _lsaddr, _size, _tag_id, _tid, _rid)	\
	_mfc_cmd (_lsaddr, (unsigned int)(_list), _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTLB_CMD))

#define _write_mfc_lf(_list, _lsaddr, _size, _tag_id, _tid, _rid)	\
	_mfc_cmd (_lsaddr, (unsigned int)(_list), _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTLF_CMD))

#define _write_mfc_rb(_ea, _lsaddr, _size, _tag_id, _tid, _rid)	\
	_MFC_CMD (_lsaddr, _ea, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTRB_CMD))

#define _write_mfc_rf(_ea, _lsaddr, _size, _tag_id, _tid, _rid)	\
	_MFC_CMD (_lsaddr, _ea, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTRF_CMD))

#define _write_mfc_rl(_list, _lsaddr, _size, _tag_id, _tid, _rid)	\
	_mfc_cmd (_lsaddr, (unsigned int)(_list), _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTRL_CMD))

#define _write_mfc_rlb(_list, _lsaddr, _size, _tag_id, _tid, _rid)	\
	_mfc_cmd (_lsaddr, (unsigned int)(_list), _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTRLB_CMD))

#define _write_mfc_rlf(_list, _lsaddr, _size, _tag_id, _tid, _rid)	\
	_mfc_cmd (_lsaddr, (unsigned int)(_list), _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTRLF_CMD))


/* Convenience macros for MFC synchronization operations.
 */
#define _read_mfc_resv(_lsaddr, _ea, _tid, _rid)	\
	_mfc_cmd (_lsaddr, _ea, 128, 0, MFC_CMD_WORD(_tid, _rid, MFC_GETLLAR_CMD))

#define _write_mfc_cond(_ea, _lsaddr, _tid, _rid)	\
	_mfc_cmd (_lsaddr, _ea, 128, 0, MFC_CMD_WORD(_tid, _rid, MFC_PUTLLC_CMD))

#define _write_mfc_uncond(_ea, _lsaddr, _tid, _rid)	\
	_mfc_cmd (_lsaddr, _ea, 128, 0, MFC_CMD_WORD(_tid, _rid, MFC_PUTLLUC_CMD))

#define _sync_mfc(_tag_id)	\
	_mfc_cmd (0, 0, 0, _tag_id, MFC_SYNC_CMD)

#define _eieio_mfc(_tag_id, _tid, _rid)	\
	_mfc_cmd (0, 0, 0, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_EIEIO_CMD))

#define _barrier_mfc(_tag_id)	\
	_mfc_cmd (0, 0, 0, _tag_id, MFC_BARRIER_CMD)

#define _send_mfc_sig(_ea, _lsaddr, _tag_id, _tid, _rid)	\
	_mfc_cmd (_lsaddr, _ea, 4, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_SNDSIG_CMD))

#define _send_mfc_sig_b(_ea, _lsaddr, _tag_id, _tid, _rid)	\
	_mfc_cmd (_lsaddr, _ea, 4, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_SNDSIGB_CMD))

#define _send_mfc_sig_f(_ea, _lsaddr, _tag_id, _tid, _rid)	\
	_mfc_cmd (_lsaddr, _ea, 4, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_SNDSIGF_CMD))


/* Convenience macros for MFC storage control operations.
 */
#define _sdcrt_mfc(_ea, _size, _tag_id, _tid, _rid)	\
	_mfc_cmd (0, _ea, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_SDCRT_CMD))

#define _sdcrtst_mfc(_ea, _size, _tag_id, _tid, _rid)	\
	_mfc_cmd (0, _ea, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_SDCRTST_CMD))

#define _sdcrz_mfc(_ea, _size, _tag_id, _tid, _rid)	\
	_mfc_cmd (0, _ea, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_SDCRZ_CMD))

#define _sdcrs_mfc(_ea, _size, _tag_id, _tid, _rid)	\
	_mfc_cmd (0, _ea, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_SDCRS_CMD))

#define _sdcrf_mfc(_ea, _size, _tag_id, _tid, _rid)	\
	_mfc_cmd (0, _ea, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_SDCRF_CMD))

/***************************************************************************/
/* 64-bit Effective Address MFC routines */
/***************************************************************************/

/* Convenience macros for MFC DMA read operations.  
 */
#define _read_mfc64(_lsaddr, _eahi, _ealo, _size, _tag_id, _tid, _rid)	\
	_MFC_CMD64 (_lsaddr, _eahi, _ealo, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_GET_CMD))

#define _read_mfc64_b(_lsaddr, _eahi, _ealo, _size, _tag_id, _tid, _rid) \
	_MFC_CMD64 (_lsaddr, _eahi, _ealo, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_GETB_CMD))

#define _read_mfc64_f(_lsaddr, _eahi, _ealo, _size, _tag_id, _tid, _rid) \
	_MFC_CMD64 (_lsaddr, _eahi, _ealo, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_GETF_CMD))

#define _read_mfc64_l(_lsaddr, _eahi, _list, _size, _tag_id, _tid, _rid) \
	_mfc_cmd64 (_lsaddr, _eahi, (unsigned int)(_list), _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_GETL_CMD))

#define _read_mfc64_lb(_lsaddr, _eahi, _list, _size, _tag_id, _tid, _rid) \
	_mfc_cmd64 (_lsaddr, _eahi, (unsigned int)(_list), _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_GETLB_CMD))

#define _read_mfc64_lf(_lsaddr, _eahi, _list, _size, _tag_id, _tid, _rid) \
	_mfc_cmd64 (_lsaddr, _eahi, (unsigned int)(_list), _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_GETLF_CMD))


/* Convenience macros for MFC DMA write operations.
 */
#define _write_mfc64(_eahi, _ealo, _lsaddr, _size, _tag_id, _tid, _rid) \
	_MFC_CMD64 (_lsaddr, _eahi, _ealo, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUT_CMD))

#define _write_mfc64_b(_eahi, _ealo, _lsaddr, _size, _tag_id, _tid, _rid) \
	_MFC_CMD64 (_lsaddr, _eahi, _ealo, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTB_CMD))

#define _write_mfc64_f(_eahi, _ealo, _lsaddr, _size, _tag_id, _tid, _rid) \
	_MFC_CMD64 (_lsaddr, _eahi, _ealo, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTF_CMD))

#define _write_mfc64_l(_eahi, _list, _lsaddr, _size, _tag_id, _tid, _rid) \
	_mfc_cmd64 (_lsaddr, _eahi, (unsigned int)(_list), _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTL_CMD))

#define _write_mfc64_r(_eahi, _ealo, _lsaddr, _size, _tag_id, _tid, _rid) \
	_MFC_CMD64 (_lsaddr, _eahi, _ealo, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTR_CMD))

#define _write_mfc64_lf(_eahi, _list, _lsaddr, _size, _tag_id, _tid, _rid) \
	_mfc_cmd64 (_lsaddr, _eahi, (unsigned int)(_list), _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTLB_CMD))

#define _write_mfc64_rb(_eahi, _ealo, _lsaddr, _size, _tag_id, _tid, _rid) \
	_MFC_CMD64 (_lsaddr, _eahi, _ealo, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTRB_CMD))

#define _write_mfc64_rf(_eahi, _ealo, _lsaddr, _size, _tag_id, _tid, _rid) \
	_MFC_CMD64 (_lsaddr, _eahi, _ealo, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTRF_CMD))

#define _write_mfc64_rl(_eahi, _list, _lsaddr, _size, _tag_id, _tid, _rid) \
	_mfc_cmd64 (_lsaddr, _eahi, (unsigned int)(_list), _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTRL_CMD))

#define _write_mfc64_rlb(_eahi, _ealo, _lsaddr, _size, _tag_id, _tid, _rid) \
	_mfc_cmd64 (_lsaddr, _eahi, _ealo, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTRLB_CMD))

#define _write_mfc64_rlf(_eahi, _list, _lsaddr, _size, _tag_id, _tid, _rid) \
	_mfc_cmd64 (_lsaddr, _eahi, (unsigned int)(_list), _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_PUTRLF_CMD))


/* Convenience macros for MFC synchronization operations.
 */
#define _read_mfc64_resv(_lsaddr, _eahi, _ealo, _tid, _rid)	\
	_mfc_cmd64 (_lsaddr, _eahi, _ealo, 128, 0, MFC_CMD_WORD(_tid, _rid, MFC_GETLLAR_CMD))

#define _write_mfc64_cond(_eahi, _ealo, _lsaddr, _tid, _rid)	\
	_mfc_cmd64 (_lsaddr, _eahi, _ealo, 128, 0, MFC_CMD_WORD(_tid, _rid, MFC_PUTLLC_CMD))

#define _write_mfc64_uncond(_eahi, _ealo, _lsaddr, _tid, _rid)	\
	_mfc_cmd64 (_lsaddr, _eahi, _ealo, 128, 0, MFC_CMD_WORD(_tid, _rid, MFC_PUTLLUC_CMD))

#define _sync_mfc64(_tag_id)	\
	_mfc_cmd64 (0, 0, 0, 0, _tag_id, MFC_SYNC_CMD)

#define _eieio_mfc64(_tag_id, _tid, _rid)	\
	_mfc_cmd64 (0, 0, 0, 0, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_EIEIO_CMD))

#define _barrier_mfc64(_tag_id)	\
	_mfc_cmd64 (0, 0, 0, 0, _tag_id, MFC_BARRIER_CMD)

#define _send_mfc64_sig(_eahi, _ealo, _lsaddr, _tag_id, _tid, _rid)	\
	_mfc_cmd64 (_lsaddr, _eahi, _ealo, 4, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_SNDSIG_CMD))

#define _send_mfc64_sig_b(_eahi, _ealo, _lsaddr, _tag_id, _tid, _rid)	\
	_mfc_cmd64 (_lsaddr, _eahi, _ealo, 4, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_SNDSIGB_CMD))

#define _send_mfc64_sig_f(_eahi, _ealo, _lsaddr, _tag_id, _tid, _rid)	\
	_mfc_cmd64 (_lsaddr, _eahi, _ealo, 4, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_SNDSIGF_CMD))


/* Convenience macros for MFC storage control operations.
 */
#define _sdcrt_mfc64(_eahi, _ealo, _size, _tag_id, _tid, _rid)	\
	_mfc_cmd64 (0, _eahi, _ealo, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_SDCRT_CMD))

#define _sdcrtst_mfc64(_eahi, _ealo, _size, _tag_id, _tid, _rid)	\
	_mfc_cmd64 (0, _eahi, _ealo, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_SDCRTST_CMD))

#define _sdcrz_mfc64(_eahi, _ealo, _size, _tag_id, _tid, _rid)	\
	_mfc_cmd64 (0, _eahi, _ealo, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_SDCRZ_CMD))

#define _sdcrs_mfc64(_eahi, _ealo, _size, _tag_id, _tid, _rid)	\
	_mfc_cmd64 (0, _eahi, _ealo, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_SDCRS_CMD))

#define _sdcrf_mfc64(_eahi, _ealo, _size, _tag_id, _tid, _rid)	\
	_mfc_cmd64 (0, _eahi, _ealo, _size, _tag_id, MFC_CMD_WORD(_tid, _rid, MFC_SDCRF_CMD))


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

/* FUNCTION:	_mfc_cmd (lsaddr, ea, size, tag_id, cmd)
 *
 * Initiate the given MFC DMA request, without polling for queue
 * space or command completion.
 */

static inline int
_mfc_cmd (volatile void *lsaddr,
	  const unsigned int ea,
	  const unsigned int size,
	  const unsigned int tag_id,
	  const unsigned int cmd)
{
  // The SPU_MFC_DEBUG macros are converted to printf()'s only if the
  // DEBUG_SPU_MFC define is set at compile time.  When the debug messages are
  // no longer necessary, recompile with the DEBUG_SPU_MFC define NOT set to
  // maximize performance of this code.
  SPU_MFC_DEBUG("\n_mfc_cmd(%p, 0x%08X, 0x%08X, 0x%02X, 0x%08X)\n",
		  lsaddr, ea, size, tag_id, cmd);
  
  // The following checks are only performed if the MFC_ERROR_CHECK define is
  // set at compile time.  If an error is detected by one of these checks then
  // this routine will return immediately with MFC_ERROR.  After an application
  // is running smoothly with the checks in place, recompile with
  // MFC_ERROR_CHECK NOT set to maximize performance of this code, by 
  // elminating the error checking overhead.
  CHECK_MFC_DMA_CMD(cmd);
  CHECK_MFC_DMA_SIZE(size, cmd);
  CHECK_MFC_DMA_ADDR_ALIGNED(lsaddr, ea, size);
  CHECK_MFC_DMA_TAGID(tag_id);
  CHECK_MFC_DMA_LS_ADDR(lsaddr);

  spu_mfcdma32 (lsaddr, ea, size, tag_id, cmd);

  return(0);
}

/* FUNCTION:	_mfc_cmd64 (lsaddr, eahi, ealo, size, tag_id, cmd)
 *
 * Initiate the given MFC DMA request, without polling for queue
 * space or command completion.  A full 64-bit effective address
 * is specified, with the upper 32-bits in 'eahi' and the lower 
 * in 32-btis in 'ealo'.
 */
static inline int
_mfc_cmd64 (volatile void *lsaddr,
	    const unsigned int eahi,
	    const unsigned int ealo,
	    const unsigned int size,
	    const unsigned int tag_id,
	    const unsigned int cmd)
{
  // The SPU_MFC_DEBUG macros are converted to printf()'s only if the
  // DEBUG_SPU_MFC define is set at compile time.  When the debug messages are
  // no longer necessary, recompile with the DEBUG_SPU_MFC define NOT set to
  // maximize performance of this code.
  SPU_MFC_DEBUG("\n_mfc_cmd64(%p, 0x%08X, 0x%08X, 0x%08X, 0x%02X, 0x%08X)\n",
		  lsaddr, eahi, ealo, size, tag_id, cmd);
  
  // The following checks are only performed if the MFC_ERROR_CHECK define is
  // set at compile time.  If an error is detected by one of these checks then
  // this routine will return immediately with MFC_ERROR.  After an application
  // is running smoothly with the checks in place, recompile with
  // MFC_ERROR_CHECK NOT set to maximize performance of this code, by 
  // elminating the error checking overhead.
  CHECK_MFC_DMA_CMD(cmd);
  CHECK_MFC_DMA_SIZE(size, cmd);
  CHECK_MFC_DMA_ADDR_ALIGNED(lsaddr, ealo, size);
  CHECK_MFC_DMA_TAGID(tag_id);
  CHECK_MFC_DMA_LS_ADDR(lsaddr);

  spu_mfcdma64 (lsaddr, eahi, ealo, size, tag_id, cmd);

  return(0);
}

/* FUNCTION:	_mfc_cmd_large (lsaddr, ea, size, tag_id, cmd)
 *
 * This routine will unroll large DMA requests (size > 16 kb).
 */
static inline int
_mfc_cmd_large (volatile void *lsaddr,
		const unsigned int ea,
		const unsigned int size,
		const unsigned int tag_id,
		const unsigned int cmd)
{
  // The SPU_MFC_DEBUG macros are converted to printf()'s only if the
  // DEBUG_SPU_MFC define is set at compile time.  When the debug messages are
  // no longer necessary, recompile with the DEBUG_SPU_MFC define NOT set to
  // maximize performance of this code.
  SPU_MFC_DEBUG("\n_mfc_cmd_large(%p, 0x%08X, 0x%08X, 0x%02X, 0x%08X)\n",
		  lsaddr, ea, size, tag_id, cmd);
  
  // The following checks are only performed if the MFC_ERROR_CHECK define is
  // set at compile time.  If an error is detected by one of these checks then
  // this routine will return immediately with MFC_ERROR.  After an application
  // is running smoothly with the checks in place, recompile with
  // MFC_ERROR_CHECK NOT set to maximize performance of this code, by 
  // elminating the error checking overhead.
  CHECK_MFC_DMA_CMD(cmd);
  CHECK_MFC_DMA_LARGE_SIZE(size, cmd);
  CHECK_MFC_DMA_ADDR_ALIGNED(lsaddr, ea, size);
  CHECK_MFC_DMA_TAGID(tag_id);
  CHECK_MFC_DMA_LS_ADDR(lsaddr);

  if (size <= MFC_MAX_DMA_SIZE)
  {
	_mfc_cmd (lsaddr, ea, size, tag_id, cmd);
  }
  else
  {
	unsigned int chunks = (size >> MFC_MAX_DMA_SIZE_SHIFT);
	unsigned int rem = (size & MFC_MAX_DMA_SIZE_MASK);
	volatile char *lsptr = lsaddr;
	unsigned int eaptr = ea;
	unsigned int i;

	for (i = 0; i < chunks; i++)
	{
	    _mfc_cmd (lsptr, eaptr, MFC_MAX_DMA_SIZE, tag_id, cmd);
	    lsptr += MFC_MAX_DMA_SIZE;
	    eaptr += MFC_MAX_DMA_SIZE;
	}
	if (rem)
	{
	    _mfc_cmd (lsptr, eaptr, rem, tag_id, cmd);
	}
  }

  return(0);
}

/* FUNCTION:	_mfc_cmd64_large (lsaddr, eahi, ealo, size, tag_id, cmd)
 *
 * This routine will unroll large DMA requests (size > 16 kb).
 */
static inline int
_mfc_cmd64_large (volatile void *lsaddr,
		const unsigned int eahi,
		const unsigned int ealo,
		const unsigned int size,
		const unsigned int tag_id,
		const unsigned int cmd)
{
  // The SPU_MFC_DEBUG macros are converted to printf()'s only if the
  // DEBUG_SPU_MFC define is set at compile time.  When the debug messages are
  // no longer necessary, recompile with the DEBUG_SPU_MFC define NOT set to
  // maximize performance of this code.
  SPU_MFC_DEBUG("\n_mfc_cmd64_large(%p, 0x%08X, 0x%08X, 0x%08X, 0x%02X, 0x%08X)\n", lsaddr, eahi, ealo, size, tag_id, cmd);
  
  // The following checks are only performed if the MFC_ERROR_CHECK define is
  // set at compile time.  If an error is detected by one of these checks then
  // this routine will return immediately with MFC_ERROR.  After an application
  // is running smoothly with the checks in place, recompile with
  // MFC_ERROR_CHECK NOT set to maximize performance of this code, by 
  // elminating the error checking overhead.
  CHECK_MFC_DMA_CMD(cmd);
  CHECK_MFC_DMA_LARGE_SIZE(size, cmd);
  CHECK_MFC_DMA_ADDR_ALIGNED(lsaddr, ealo, size);
  CHECK_MFC_DMA_TAGID(tag_id);
  CHECK_MFC_DMA_LS_ADDR(lsaddr);

  if (size <= MFC_MAX_DMA_SIZE)
  {
	_mfc_cmd64 (lsaddr, eahi, ealo, size, tag_id, cmd);
  }
  else
  {
	unsigned int chunks = (size >> MFC_MAX_DMA_SIZE_SHIFT);
	unsigned int rem = (size & MFC_MAX_DMA_SIZE_MASK);
	volatile char *lsptr = lsaddr;
	unsigned int eaptr = ealo;
	unsigned int i;

	for (i = 0; i < chunks; i++)
	{
	    _mfc_cmd64 (lsptr, eahi, eaptr, MFC_MAX_DMA_SIZE, tag_id, cmd);
	    lsptr += MFC_MAX_DMA_SIZE;
	    eaptr += MFC_MAX_DMA_SIZE;
	}
	if (rem)
	{
	    _mfc_cmd64 (lsptr, eahi, eaptr, rem, tag_id, cmd);
	}
  }

  return(0);
}

/*******************************************************************
* unsigned int
* _get_mfc_freespace(void)
*
*	Poll and immediately return the number of entries
*	available in the $mfc_cmd_queue.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_get_mfc_freespace (void)
{
    SPU_MFC_DEBUG("\n_get_mfc_freespace()\n");

    return(spu_readchcnt(MFC_CMD_QUEUE));
}
#else
#define _get_mfc_freespace()	spu_readchcnt(MFC_CMD_QUEUE)
#endif


/*******************************************************************
* unsigned int
* _wait_mfc_freespace (unsigned int space)
*
*		Busy poll until the specified amount of space is
*		available in the MFC_CMD_QUEUE.   Actual amount of
*		free space is returned.
*******************************************************************/

static inline unsigned int 
_wait_mfc_freespace (unsigned int space)
{
    volatile unsigned int freespace;

    SPU_MFC_DEBUG("\n_wait_mfc_freespace(0x%08X)\n", space);
  
    if (space > MFC_SPU_MAX_QUEUE_SPACE)
	space = MFC_SPU_MAX_QUEUE_SPACE;

    do
    {
	freespace = _get_mfc_freespace();
    }
    while (freespace < space);

    return (freespace);
}

/*******************************************************************
* void
* _set_mfc_tagmask (const unsigned int mask)
*
*		Set the MFC tag mask.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline void
_set_mfc_tagmask (const unsigned int mask)
{
    SPU_MFC_DEBUG("\n_set_mfc_tagmask(0x%08X)\n", mask);

    spu_writech (MFC_WR_TAG_MASK, mask);
}
#else
#define _set_mfc_tagmask(mask)  spu_writech (MFC_WR_TAG_MASK, mask)
#endif

#ifdef CONFIG_BPA_RFC_34
/* The following interface is only available and usable on DD2.0 or newer
 * BE HW.
 */
/*******************************************************************
* unsigned int
* _get_mfc_tagmask (void)
*
*		Read the MFC tag mask.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_get_mfc_tagmask (void)
{
    SPU_MFC_DEBUG("\n_get_mfc_tagmask()\n");

    return(spu_readch (MFC_RD_TAG_MASK));
}
#else
#define _get_mfc_tagmask()  spu_readch (MFC_RD_TAG_MASK)
#endif

#endif /* CONFIG_BPA_RFC_34 */

/*******************************************************************
* unsigned int
* _stat_mfc_tagmask (void)
*
*		Read and immediately return the current tag completion 
*		status, as defined by the current setting of the tag 
*		status mask register.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_stat_mfc_tagmask (void)
{
    SPU_MFC_DEBUG("\n_stat_mfc_tagmask()\n");

    return(spu_mfcstat(MFC_TAG_UPDATE_IMMED));
}
#else
#define _stat_mfc_tagmask()	spu_mfcstat(MFC_TAG_UPDATE_IMMED)
#endif


/*******************************************************************
* unsigned int
* _wait_mfc_tags_any (void)
*
*		Wait (sleep) for any tags to complete, as defined by
*		the current setting of the tag status mask, and return
*		the current completion status.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_wait_mfc_tags_any (void)
{
    SPU_MFC_DEBUG("\n_wait_mfc_tags_any()\n");

    return(spu_mfcstat(MFC_TAG_UPDATE_ANY));
}
#else
#define _wait_mfc_tags_any()	spu_mfcstat(MFC_TAG_UPDATE_ANY)
#endif


/*******************************************************************
* unsigned int
* _wait_mfc_tags_all (void)
*
*		Wait (sleep) for all tags to complete, as defined by
*		the current setting of the tag status mask.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_wait_mfc_tags_all (void)
{
    SPU_MFC_DEBUG("\n_wait_mfc_tags_all()\n");

    return(spu_mfcstat(MFC_TAG_UPDATE_ALL));
}
#else
#define _wait_mfc_tags_all()	spu_mfcstat(MFC_TAG_UPDATE_ALL)
#endif


/*******************************************************************
* unsigned int
* _get_mfc_event_status(void)
*
*		Read the status of the external events that are
*		indicated in the external event mask.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_get_mfc_event_status (void)
{
    SPU_MFC_DEBUG("\n_get_mfc_event_status()\n");

    return(spu_readch(MFC_RD_EVENT_STATUS));
}
#else
#define _get_mfc_event_status()		spu_readch(MFC_RD_EVENT_STATUS)
#endif


/*******************************************************************
* unsigned int
* _stat_mfc_event_status(void)
*
*		Read the channel count of the External Event Status
*		channel.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_stat_mfc_event_status (void)
{
    SPU_MFC_DEBUG("\n_stat_mfc_event_status()\n");

    return(spu_readchcnt(MFC_RD_EVENT_STATUS));
}
#else
#define _stat_mfc_event_status()	spu_readchcnt(MFC_RD_EVENT_STATUS)
#endif


/*******************************************************************
* void
* _put_mfc_event_mask (const unsigned int emask)
*
*		Set the external event mask.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline void
_put_mfc_event_mask (const unsigned int emask)
{
    SPU_MFC_DEBUG("\n_put_mfc_event_mask(0x%08X)\n", emask);

    spu_writech(MFC_WR_EVENT_MASK, emask);
}
#else
#define _put_mfc_event_mask(emask)      spu_writech(MFC_WR_EVENT_MASK, emask)
#endif


#ifdef CONFIG_BPA_RFC_34
/* The following interface is only available and usable on DD2.0 or newer
 * BE HW.
 */
/*******************************************************************
* unsigned int
* _get_mfc_event_mask (void)
*
*		Read the external event mask.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_get_mfc_event_mask (void)
{
    SPU_MFC_DEBUG("\n_get_mfc_event_mask()\n");

    return(spu_readch(MFC_RD_EVENT_MASK));
}
#else
#define _get_mfc_event_mask()      spu_readch(MFC_RD_EVENT_MASK)
#endif

#endif /* CONFIG_BPA_RFC_34 */

/*******************************************************************
* void
* _put_mfc_event_ack (const unsigned int ack)
*
*		Acknowledge the external events that have been
*		serviced by the software.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline void
_put_mfc_event_ack (const unsigned int ack)
{
    SPU_MFC_DEBUG("\n_put_mfc_event_ack(0x%08X)\n", ack);

    spu_writech(MFC_WR_EVENT_ACK, ack);
}
#else
#define _put_mfc_event_ack(ack)         spu_writech(MFC_WR_EVENT_ACK, ack)
#endif



/*******************************************************************
* void
* _put_mfc_decr (int count)
*
*		Write a 32-bit value to the decrementer.  Writing
*		zero will cause an immediate decrementer event
*		(if unmasked).
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline void
_put_mfc_decr (const int count)
{
    SPU_MFC_DEBUG("\n_put_mfc_decr(0x%08X)\n", count);

    spu_writech (MFC_WR_DECR_COUNT, count);
}
#else
#define _put_mfc_decr(count)		spu_writech(MFC_WR_DECR_COUNT, count)
#endif



/*******************************************************************
* int
* _get_mfc_decr (void)
*
*		Read the current 32-bit value of the decrementer.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline int
_get_mfc_decr (void)
{
    SPU_MFC_DEBUG("\n_get_mfc_decr()\n");

    return(spu_readch(MFC_RD_DECR_COUNT));
}
#else
#define _get_mfc_decr()			spu_readch(MFC_RD_DECR_COUNT)
#endif


/*******************************************************************
* unsigned int
* _get_mfc_llar_status (void)
*
*		Get status of the most recent lock line reservation 
*		command (getllar, putllc, or putlluc).
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_get_mfc_llar_status (void)
{
    SPU_MFC_DEBUG("\n_get_mfc_llar_status()\n");

    return(spu_readch(MFC_RD_LLAR_STATUS));
}
#else
#define _get_mfc_llar_status()		spu_readch(MFC_RD_LLAR_STATUS)
#endif


/*******************************************************************
* unsigned int
* _stat_mfc_llar_status (void)
*
*		Get count of the most recent lock line reservation 
*		command (getllar, putllc, or putlluc).
*		Use this routine instead of _get_mfc_llar_status()
*		to avoid stalling the SPU when waiting for a lock
*		line reservation command to complete.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_stat_mfc_llar_status (void)
{
    SPU_MFC_DEBUG("\n_stat_mfc_llar_status()\n");

    return(spu_readchcnt(MFC_RD_LLAR_STATUS));
}
#else
#define _stat_mfc_llar_status()		spu_readchcnt(MFC_RD_LLAR_STATUS)
#endif


/*******************************************************************
* unsigned int
* _get_mfc_dmal_status (void)
*
*		Wait (sleep) until a "stall and notify" condition exists,
*		and then return a bit set for each tag group that has
*		a DMA list command stalled.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_get_mfc_dmal_status (void)
{
    SPU_MFC_DEBUG("\n_get_mfc_dmal_status()\n");

    return(spu_readch(MFC_RD_DMAL_STATUS));
}
#else
#define _get_mfc_dmal_status()		spu_readch(MFC_RD_DMAL_STATUS)
#endif


/*******************************************************************
* unsigned int
* _stat_mfc_dmal_status (void)
*
*		Check to see if a "stall and notify" condition exists,
*		returns 1 when TRUE and 0 when FALSE.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_stat_mfc_dmal_status (void)
{
    SPU_MFC_DEBUG("\n_stat_mfc_dmal_status()\n");

    return(spu_readchcnt(MFC_RD_DMAL_STATUS));
}
#else
#define _stat_mfc_dmal_status()		spu_readchcnt(MFC_RD_DMAL_STATUS)
#endif


/*******************************************************************
* void
* _put_mfc_dmal_ack (const unsigned int tag_id)
*
*		Write an acknowledgement of a DMA list element stall
*		condition in a tag group that has stopped DMA processing
*		due to the "stall & notify" flag being set.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline void
_put_mfc_dmal_ack (const unsigned int tag_id)
{
    SPU_MFC_DEBUG("\n_put_mfc_dmal_ack(0x%08X)\n", tag_id);

    spu_writech (MFC_WR_DMAL_ACK, tag_id);
}
#else
#define _put_mfc_dmal_ack(tag_id)	spu_writech(MFC_WR_DMAL_ACK, tag_id)
#endif


/*******************************************************************
* unsigned int
* _get_mfc_inbox (void)
*
*		Return the contents of the PU->SPU mailbox.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_get_mfc_inbox (void)
{
    SPU_MFC_DEBUG("\n_get_mfc_inbox()\n");

    return(spu_readch(MFC_RD_MAILBOX));
}
#else
#define _get_mfc_inbox()		spu_readch(MFC_RD_MAILBOX)
#endif


/*******************************************************************
* void
* _put_mfc_outbox (const unsigned int val)
*
*		Set the contents of the SPU->PU mailbox.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline void
_put_mfc_outbox (const unsigned int val)
{
    SPU_MFC_DEBUG("\n_put_mfc_outbox(0x%08X)\n", val);

    spu_writech (MFC_WR_MAILBOX, val);
}
#else
#define _put_mfc_outbox(val)		spu_writech (MFC_WR_MAILBOX, val)
#endif


/*******************************************************************
* void
* _put_mfc_outbox_intr (const unsigned int val)
*
*		Set the contents of the SPU->PU interrupting mailbox,
*		triggering an external interrupt on the PU.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline void
_put_mfc_outbox_intr (const unsigned int val)
{
    SPU_MFC_DEBUG("\n_put_mfc_outbox_intr(0x%08X)\n", val);

    spu_writech (MFC_WR_INTR_MAILBOX, val);
}
#else
#define _put_mfc_outbox_intr(val)	spu_writech (MFC_WR_INTR_MAILBOX, val)
#endif


/*******************************************************************
* unsigned int
* _stat_mfc_inbox (void)
*
*		Get the status for the PU->SPU mailbox.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_stat_mfc_inbox (void)
{
    SPU_MFC_DEBUG("\n_stat_mfc_inbox()\n");

    return(spu_readchcnt (MFC_RD_MAILBOX));
}
#else
#define _stat_mfc_inbox()		spu_readchcnt (MFC_RD_MAILBOX)
#endif


/*******************************************************************
* unsigned int
* _stat_mfc_outbox (void)
*
* unsigned int
* _stat_mfc_outbox_intr (void)
*
*		Get the status for the SPU->PU mailbox
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_stat_mfc_outbox (void)
{
    SPU_MFC_DEBUG("\n_stat_mfc_outbox()\n");

    return(spu_readchcnt (MFC_WR_MAILBOX));
}
#else
#define _stat_mfc_outbox()		spu_readchcnt (MFC_WR_MAILBOX)
#endif

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_stat_mfc_outbox_intr (void)
{
    SPU_MFC_DEBUG("\n_stat_mfc_outbox_intr()\n");

    return(spu_readchcnt (MFC_WR_INTR_MAILBOX));
}
#else
#define _stat_mfc_outbox_intr()		spu_readchcnt (MFC_WR_INTR_MAILBOX)
#endif


/*******************************************************************
* unsigned int
* _wait_mfc_sig1 (void)
*
*		Wait (sleep) for the contents of $mfc_signal_1 channel to 
*		become non-zero, and return the signal value.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_wait_mfc_sig1 (void)
{
    SPU_MFC_DEBUG("\n_wait_mfc_sig1()\n");

    return(spu_readch (MFC_RD_SIGNAL_1));
}
#else
#define _wait_mfc_sig1()		spu_readch (MFC_RD_SIGNAL_1)
#endif


/*******************************************************************
* unsigned int
* _wait_mfc_sig2 (void)
*
*		Wait (sleep) for the contents of $mfc_signal_2 channel to 
*		become non-zero, and return the signal value.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_wait_mfc_sig2 (void)
{
    SPU_MFC_DEBUG("\n_wait_mfc_sig2()\n");

    return(spu_readch (MFC_RD_SIGNAL_2));
}
#else
#define _wait_mfc_sig2()		spu_readch (MFC_RD_SIGNAL_2)
#endif


/*******************************************************************
* unsigned int
* _stat_mfc_sig1 (void)
*
*		Get the status (channel count) for $mfc_signal_1.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_stat_mfc_sig1 (void)
{
    SPU_MFC_DEBUG("\n_stat_mfc_sig1()\n");

    return(spu_readchcnt (MFC_RD_SIGNAL_1));
}
#else
#define _stat_mfc_sig1()		spu_readchcnt (MFC_RD_SIGNAL_1)
#endif


/*******************************************************************
* unsigned int
* _stat_mfc_sig2 (void)
*
*		Get the status (channel count) for $mfc_signal_1.
*******************************************************************/

#ifdef DEBUG_SPU_MFC
static inline unsigned int
_stat_mfc_sig2 (void)
{
    SPU_MFC_DEBUG("\n_stat_mfc_sig2()\n");

    return(spu_readchcnt (MFC_RD_SIGNAL_2));
}
#else
#define _stat_mfc_sig2()		spu_readchcnt (MFC_RD_SIGNAL_2)
#endif

#endif /* _mfc_h_ */
